# coding: utf-8

"""
    VMware Aria Automation Assembler Blueprint API

    A multi-cloud Blueprint API for VMware Aria Automation Services  This page describes the RESTful APIs for Blueprint. The APIs facilitate CRUD operations on the various resources and entities used throughout Blueprint (Blueprints, Blueprint Terraform Integrations , PropertyGroups , etc.) and allow operations on them (creating a Blueprint, creating a Property group, etc.).  The APIs that list collections of resources  also support OData like implementation. Below query params can be used across Blueprint entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/blueprint/api/blueprints?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/blueprint/api/blueprints?$top=10&$skip=2```   # noqa: E501

    OpenAPI spec version: 2019-09-12
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PageResourceTypeContent(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'created_at': 'datetime',
        'created_by': 'str',
        'updated_at': 'datetime',
        'updated_by': 'str',
        'org_id': 'str',
        'provider_name': 'str',
        'provider_version': 'str',
        'provider_id': 'str',
        'name': 'str',
        'display_name': 'str',
        'description': 'str',
        'operations': 'dict(str, str)',
        'schema': 'PageResourceTypeSchema',
        'endpoint_type': 'str'
    }

    attribute_map = {
        'id': 'id',
        'created_at': 'createdAt',
        'created_by': 'createdBy',
        'updated_at': 'updatedAt',
        'updated_by': 'updatedBy',
        'org_id': 'orgId',
        'provider_name': 'providerName',
        'provider_version': 'providerVersion',
        'provider_id': 'providerId',
        'name': 'name',
        'display_name': 'displayName',
        'description': 'description',
        'operations': 'operations',
        'schema': 'schema',
        'endpoint_type': 'endpointType'
    }

    def __init__(self, id=None, created_at=None, created_by=None, updated_at=None, updated_by=None, org_id=None, provider_name=None, provider_version=None, provider_id=None, name=None, display_name=None, description=None, operations=None, schema=None, endpoint_type=None):  # noqa: E501
        """PageResourceTypeContent - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._created_at = None
        self._created_by = None
        self._updated_at = None
        self._updated_by = None
        self._org_id = None
        self._provider_name = None
        self._provider_version = None
        self._provider_id = None
        self._name = None
        self._display_name = None
        self._description = None
        self._operations = None
        self._schema = None
        self._endpoint_type = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if created_at is not None:
            self.created_at = created_at
        if created_by is not None:
            self.created_by = created_by
        if updated_at is not None:
            self.updated_at = updated_at
        if updated_by is not None:
            self.updated_by = updated_by
        if org_id is not None:
            self.org_id = org_id
        if provider_name is not None:
            self.provider_name = provider_name
        if provider_version is not None:
            self.provider_version = provider_version
        if provider_id is not None:
            self.provider_id = provider_id
        if name is not None:
            self.name = name
        if display_name is not None:
            self.display_name = display_name
        if description is not None:
            self.description = description
        if operations is not None:
            self.operations = operations
        if schema is not None:
            self.schema = schema
        if endpoint_type is not None:
            self.endpoint_type = endpoint_type

    @property
    def id(self):
        """Gets the id of this PageResourceTypeContent.  # noqa: E501

        Object ID  # noqa: E501

        :return: The id of this PageResourceTypeContent.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this PageResourceTypeContent.

        Object ID  # noqa: E501

        :param id: The id of this PageResourceTypeContent.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def created_at(self):
        """Gets the created_at of this PageResourceTypeContent.  # noqa: E501

        Created time  # noqa: E501

        :return: The created_at of this PageResourceTypeContent.  # noqa: E501
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this PageResourceTypeContent.

        Created time  # noqa: E501

        :param created_at: The created_at of this PageResourceTypeContent.  # noqa: E501
        :type: datetime
        """

        self._created_at = created_at

    @property
    def created_by(self):
        """Gets the created_by of this PageResourceTypeContent.  # noqa: E501

        Created by  # noqa: E501

        :return: The created_by of this PageResourceTypeContent.  # noqa: E501
        :rtype: str
        """
        return self._created_by

    @created_by.setter
    def created_by(self, created_by):
        """Sets the created_by of this PageResourceTypeContent.

        Created by  # noqa: E501

        :param created_by: The created_by of this PageResourceTypeContent.  # noqa: E501
        :type: str
        """

        self._created_by = created_by

    @property
    def updated_at(self):
        """Gets the updated_at of this PageResourceTypeContent.  # noqa: E501

        Updated time  # noqa: E501

        :return: The updated_at of this PageResourceTypeContent.  # noqa: E501
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this PageResourceTypeContent.

        Updated time  # noqa: E501

        :param updated_at: The updated_at of this PageResourceTypeContent.  # noqa: E501
        :type: datetime
        """

        self._updated_at = updated_at

    @property
    def updated_by(self):
        """Gets the updated_by of this PageResourceTypeContent.  # noqa: E501

        Updated by  # noqa: E501

        :return: The updated_by of this PageResourceTypeContent.  # noqa: E501
        :rtype: str
        """
        return self._updated_by

    @updated_by.setter
    def updated_by(self, updated_by):
        """Sets the updated_by of this PageResourceTypeContent.

        Updated by  # noqa: E501

        :param updated_by: The updated_by of this PageResourceTypeContent.  # noqa: E501
        :type: str
        """

        self._updated_by = updated_by

    @property
    def org_id(self):
        """Gets the org_id of this PageResourceTypeContent.  # noqa: E501

        Org ID  # noqa: E501

        :return: The org_id of this PageResourceTypeContent.  # noqa: E501
        :rtype: str
        """
        return self._org_id

    @org_id.setter
    def org_id(self, org_id):
        """Sets the org_id of this PageResourceTypeContent.

        Org ID  # noqa: E501

        :param org_id: The org_id of this PageResourceTypeContent.  # noqa: E501
        :type: str
        """

        self._org_id = org_id

    @property
    def provider_name(self):
        """Gets the provider_name of this PageResourceTypeContent.  # noqa: E501

        Provider name  # noqa: E501

        :return: The provider_name of this PageResourceTypeContent.  # noqa: E501
        :rtype: str
        """
        return self._provider_name

    @provider_name.setter
    def provider_name(self, provider_name):
        """Sets the provider_name of this PageResourceTypeContent.

        Provider name  # noqa: E501

        :param provider_name: The provider_name of this PageResourceTypeContent.  # noqa: E501
        :type: str
        """

        self._provider_name = provider_name

    @property
    def provider_version(self):
        """Gets the provider_version of this PageResourceTypeContent.  # noqa: E501

        Provider version  # noqa: E501

        :return: The provider_version of this PageResourceTypeContent.  # noqa: E501
        :rtype: str
        """
        return self._provider_version

    @provider_version.setter
    def provider_version(self, provider_version):
        """Sets the provider_version of this PageResourceTypeContent.

        Provider version  # noqa: E501

        :param provider_version: The provider_version of this PageResourceTypeContent.  # noqa: E501
        :type: str
        """

        self._provider_version = provider_version

    @property
    def provider_id(self):
        """Gets the provider_id of this PageResourceTypeContent.  # noqa: E501

        Provider Id  # noqa: E501

        :return: The provider_id of this PageResourceTypeContent.  # noqa: E501
        :rtype: str
        """
        return self._provider_id

    @provider_id.setter
    def provider_id(self, provider_id):
        """Sets the provider_id of this PageResourceTypeContent.

        Provider Id  # noqa: E501

        :param provider_id: The provider_id of this PageResourceTypeContent.  # noqa: E501
        :type: str
        """

        self._provider_id = provider_id

    @property
    def name(self):
        """Gets the name of this PageResourceTypeContent.  # noqa: E501

        Resource type name  # noqa: E501

        :return: The name of this PageResourceTypeContent.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this PageResourceTypeContent.

        Resource type name  # noqa: E501

        :param name: The name of this PageResourceTypeContent.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def display_name(self):
        """Gets the display_name of this PageResourceTypeContent.  # noqa: E501

        Resource type display name  # noqa: E501

        :return: The display_name of this PageResourceTypeContent.  # noqa: E501
        :rtype: str
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """Sets the display_name of this PageResourceTypeContent.

        Resource type display name  # noqa: E501

        :param display_name: The display_name of this PageResourceTypeContent.  # noqa: E501
        :type: str
        """

        self._display_name = display_name

    @property
    def description(self):
        """Gets the description of this PageResourceTypeContent.  # noqa: E501

        Resource type description  # noqa: E501

        :return: The description of this PageResourceTypeContent.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this PageResourceTypeContent.

        Resource type description  # noqa: E501

        :param description: The description of this PageResourceTypeContent.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def operations(self):
        """Gets the operations of this PageResourceTypeContent.  # noqa: E501

        Provider resource operations  # noqa: E501

        :return: The operations of this PageResourceTypeContent.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._operations

    @operations.setter
    def operations(self, operations):
        """Sets the operations of this PageResourceTypeContent.

        Provider resource operations  # noqa: E501

        :param operations: The operations of this PageResourceTypeContent.  # noqa: E501
        :type: dict(str, str)
        """

        self._operations = operations

    @property
    def schema(self):
        """Gets the schema of this PageResourceTypeContent.  # noqa: E501


        :return: The schema of this PageResourceTypeContent.  # noqa: E501
        :rtype: PageResourceTypeSchema
        """
        return self._schema

    @schema.setter
    def schema(self, schema):
        """Sets the schema of this PageResourceTypeContent.


        :param schema: The schema of this PageResourceTypeContent.  # noqa: E501
        :type: PageResourceTypeSchema
        """

        self._schema = schema

    @property
    def endpoint_type(self):
        """Gets the endpoint_type of this PageResourceTypeContent.  # noqa: E501

        Endpoint type  # noqa: E501

        :return: The endpoint_type of this PageResourceTypeContent.  # noqa: E501
        :rtype: str
        """
        return self._endpoint_type

    @endpoint_type.setter
    def endpoint_type(self, endpoint_type):
        """Sets the endpoint_type of this PageResourceTypeContent.

        Endpoint type  # noqa: E501

        :param endpoint_type: The endpoint_type of this PageResourceTypeContent.  # noqa: E501
        :type: str
        """

        self._endpoint_type = endpoint_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PageResourceTypeContent, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PageResourceTypeContent):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
